org.apache.ignite.cluster

## Interface ClusterMetrics

All Known Subinterfaces:
  ClusterMetricsMXBean

All Known Implementing Classes:
  ClusterLocalNodeMetricsMXBeanImpl, ClusterMetricsImpl, ClusterMetricsMXBeanImpl, ClusterMetricsSnapshot

    public interface ClusterMetrics

This class represents runtime information on a cluster. Apart from obvious statistical value, this information is used for implementation of load balancing, failover, and collision SPIs. For example, collision SPI in combination with fail-over SPI could check if other nodes don't have any active or waiting jobs and fail-over some jobs to those nodes.

Node metrics for any node can be accessed via `ClusterNode.metrics()` method. Keep in mind that there will be a certain network delay (usually equal to metrics update delay) for the accuracy of node metrics. However, when accessing metrics on local node `IgniteCluster.localNode().getMetrics()` the metrics are always accurate and up to date.

Local node metrics are registered as `MBean` and can be accessed from any JMX management console. The simplest way is to use standard `jconsole` that comes with JDK as it also provides ability to view any node parameter as a graph.

### Method Summary

All Methods Instance Methods Abstract Methods
`float` `getAverageActiveJobs()` Gets average number of active jobs concurrently executing on the node.
`float` `getAverageCancelledJobs()` Gets average number of cancelled jobs this node ever had running concurrently.
`double` `getAverageCpuLoad()` Gets average of CPU load values over all metrics kept in the history.
`double` `getAverageJobExecuteTime()` Gets average time a job takes to execute on the node.
`double` `getAverageJobWaitTime()` Gets average time jobs spend waiting in the queue to be executed.
`float` `getAverageRejectedJobs()` Gets average number of jobs this node rejects during collision resolution operations.
`float` `getAverageWaitingJobs()` Gets average number of waiting jobs this node had queued.
`float` `getBusyTimePercentage()` Gets percentage of time this node is busy executing jobs vs. idling.
`int` `getCurrentActiveJobs()` Gets number of currently active jobs concurrently executing on the node.
`int` `getCurrentCancelledJobs()` Gets number of cancelled jobs that are still running.
`double` `getCurrentCpuLoad()` Returns the CPU usage usage in `[0, 1]` range.
`int` `getCurrentDaemonThreadCount()` Returns the current number of live daemon threads.
`double` `getCurrentGcCpuLoad()` Returns average time spent in CG since the last update.
`long` `getCurrentIdleTime()` Gets time this node spend idling since executing last job.
`long` `getCurrentJobExecuteTime()` Gets longest time a current job has been executing for.
`long` `getCurrentJobWaitTime()` Gets current time an oldest jobs has spent waiting to be executed.
`long` `getCurrentPmeDuration()` Gets execution duration for current partition map exchange in milliseconds.
`int` `getCurrentRejectedJobs()` Gets number of jobs rejected after more recent collision resolution operation.
`int` `getCurrentThreadCount()` Returns the current number of live threads including both daemon and non-daemon threads.
`int` `getCurrentWaitingJobs()` Gets number of queued jobs currently waiting to be executed.
`long` `getHeapMemoryCommitted()` Returns the amount of heap memory in bytes that is committed for the JVM to use.
`long` `getHeapMemoryInitialized()` Returns the amount of heap memory in bytes that the JVM initially requests from the operating system for memory management.
`long` `getHeapMemoryMaximum()` Returns the maximum amount of heap memory in bytes that can be used for memory management.
`long` `getHeapMemoryTotal()` Returns the total amount of heap memory in bytes.
`long` `getHeapMemoryUsed()` Returns the current heap size that is used for object allocation.
`float` `getIdleTimePercentage()` Gets percentage of time this node is idling vs. executing jobs.
`long` `getLastDataVersion()` In-Memory Data Grid assigns incremental versions to all cache operations.
`long` `getLastUpdateTime()` Gets last update time of this node metrics.
`int` `getMaximumActiveJobs()` Gets maximum number of jobs that ever ran concurrently on this node.
`int` `getMaximumCancelledJobs()` Gets maximum number of cancelled jobs this node ever had running concurrently.
`long` `getMaximumJobExecuteTime()` Gets time it took to execute the longest job on the node.
`long` `getMaximumJobWaitTime()` Gets maximum time a job ever spent waiting in a queue to be executed.
`int` `getMaximumRejectedJobs()` Gets maximum number of jobs rejected at once during a single collision resolution operation.
`int` `getMaximumThreadCount()` Returns the maximum live thread count since the JVM started or peak was reset.
`int` `getMaximumWaitingJobs()` Gets maximum number of waiting jobs this node had.
`long` `getNodeStartTime()` Returns the start time of grid node in milliseconds.
`long` `getNonHeapMemoryCommitted()` Returns the amount of non-heap memory in bytes that is committed for the JVM to use.
`long` `getNonHeapMemoryInitialized()` Returns the amount of non-heap memory in bytes that the JVM initially requests from the operating system for memory management.
`long` `getNonHeapMemoryMaximum()` Returns the maximum amount of non-heap memory in bytes that can be used for memory management.
`long` `getNonHeapMemoryTotal()` Returns the total amount of non-heap memory in bytes that can be used for memory management.
`long` `getNonHeapMemoryUsed()` Returns the current non-heap memory size that is used by Java VM.
`int` `getOutboundMessagesQueueSize()` Gets outbound messages queue size.
`long` `getReceivedBytesCount()` Gets received bytes count.
`int` `getReceivedMessagesCount()` Gets received messages count.
`long` `getSentBytesCount()` Gets sent bytes count.
`int` `getSentMessagesCount()` Gets sent messages count.
`long` `getStartTime()` Returns the start time of the JVM in milliseconds.
`long` `getTotalBusyTime()` Gets total time this node spent executing jobs.
`int` `getTotalCancelledJobs()` Gets number of cancelled jobs since node startup.
`int` `getTotalCpus()` Returns the number of CPUs available to the Java Virtual Machine.
`int` `getTotalExecutedJobs()` Gets total number of jobs handled by the node since node startup.
`int` `getTotalExecutedTasks()` Gets total number of tasks handled by the node.
`long` `getTotalIdleTime()` Gets total time this node spent idling (not executing any jobs).
`long` `getTotalJobsExecutionTime()` Gets total time all finished jobs takes to execute on the node since node startup.
`int` `getTotalNodes()` Gets total number of nodes.
`int` `getTotalRejectedJobs()` Gets total number of jobs this node rejects during collision resolution operations since node startup.
`long` `getTotalStartedThreadCount()` Returns the total number of threads created and also started since the JVM started.
`long` `getUpTime()` Returns the uptime of the JVM in milliseconds.

### Method Detail

#### getLastUpdateTime

    long getLastUpdateTime()

Gets last update time of this node metrics.

Returns:
  Last update time.

#### getMaximumActiveJobs

    int getMaximumActiveJobs()

Gets maximum number of jobs that ever ran concurrently on this node. Note that this different from `getTotalExecutedJobs()` metric and only reflects maximum number of jobs that ran at the same time.

Note: all aggregated metrics like average, minimum, maximum, total, count are calculated over all the metrics kept in history. The history size is set via either one or both of configuration settings:

- `IgniteConfiguration.getMetricsExpireTime()`
- `IgniteConfiguration.getMetricsHistorySize()`

Returns:
  Maximum number of jobs that ever ran concurrently on this node.

#### getCurrentActiveJobs

    int getCurrentActiveJobs()

Gets number of currently active jobs concurrently executing on the node.

Returns:
  Number of currently active jobs concurrently executing on the node.

#### getAverageActiveJobs

    float getAverageActiveJobs()

Gets average number of active jobs concurrently executing on the node.

Note: all aggregated metrics like average, minimum, maximum, total, count are calculated over all the metrics kept in history. The history size is set via either one or both of configuration settings:

- `IgniteConfiguration.getMetricsExpireTime()`
- `IgniteConfiguration.getMetricsHistorySize()`

Returns:
  Average number of active jobs.

#### getMaximumWaitingJobs

    int getMaximumWaitingJobs()

Gets maximum number of waiting jobs this node had.

Note: all aggregated metrics like average, minimum, maximum, total, count are calculated over all the metrics kept in history. The history size is set via either one or both of configuration settings:

- `IgniteConfiguration.getMetricsExpireTime()`
- `IgniteConfiguration.getMetricsHistorySize()`

Returns:
  Maximum number of waiting jobs.

#### getCurrentWaitingJobs

    int getCurrentWaitingJobs()

Gets number of queued jobs currently waiting to be executed.

Returns:
  Number of queued jobs currently waiting to be executed.

#### getAverageWaitingJobs

    float getAverageWaitingJobs()

Gets average number of waiting jobs this node had queued.

Note: all aggregated metrics like average, minimum, maximum, total, count are calculated over all the metrics kept in history. The history size is set via either one or both of configuration settings:

- `IgniteConfiguration.getMetricsExpireTime()`
- `IgniteConfiguration.getMetricsHistorySize()`

Returns:
  Average number of waiting jobs.

#### getMaximumRejectedJobs

    int getMaximumRejectedJobs()

Gets maximum number of jobs rejected at once during a single collision resolution operation.

Note: all aggregated metrics like average, minimum, maximum, total, count are calculated over all the metrics kept in history. The history size is set via either one or both of configuration settings:

- `IgniteConfiguration.getMetricsExpireTime()`
- `IgniteConfiguration.getMetricsHistorySize()`

Returns:
  Maximum number of jobs rejected at once.

#### getCurrentRejectedJobs

    int getCurrentRejectedJobs()

Gets number of jobs rejected after more recent collision resolution operation.

Returns:
  Number of jobs rejected after more recent collision resolution operation.

#### getAverageRejectedJobs

    float getAverageRejectedJobs()

Gets average number of jobs this node rejects during collision resolution operations.

Note: all aggregated metrics like average, minimum, maximum, total, count are calculated over all the metrics kept in history. The history size is set via either one or both of grid configuration settings:

- `IgniteConfiguration.getMetricsExpireTime()`
- `IgniteConfiguration.getMetricsHistorySize()`

Returns:
  Average number of jobs this node rejects during collision resolution operations.

#### getTotalRejectedJobs

    int getTotalRejectedJobs()

Gets total number of jobs this node rejects during collision resolution operations since node startup.

Note: Unlike most of other aggregation metrics this metric is not calculated over history but over the entire node life.

Returns:
  Total number of jobs this node rejects during collision resolution operations since node startup.

#### getMaximumCancelledJobs

    int getMaximumCancelledJobs()

Gets maximum number of cancelled jobs this node ever had running concurrently.

Returns:
  Maximum number of cancelled jobs.

#### getCurrentCancelledJobs

    int getCurrentCancelledJobs()

Gets number of cancelled jobs that are still running. Just like regular java threads, jobs will receive cancel notification, but it's ultimately up to the job itself to gracefully exit.

Returns:
  Number of cancelled jobs that are still running.

#### getAverageCancelledJobs

    float getAverageCancelledJobs()

Gets average number of cancelled jobs this node ever had running concurrently.

Note: all aggregated metrics like average, minimum, maximum, total, count are calculated over all the metrics kept in history. The history size is set via either one or both of configuration settings:

- `IgniteConfiguration.getMetricsExpireTime()`
- `IgniteConfiguration.getMetricsHistorySize()`

Returns:
  Average number of cancelled jobs.

#### getTotalCancelledJobs

    int getTotalCancelledJobs()

Gets number of cancelled jobs since node startup.

Note: Unlike most of other aggregation metrics this metric is not calculated over history but over the entire node life.

Returns:
  Total number of cancelled jobs since node startup.

#### getTotalExecutedJobs

    int getTotalExecutedJobs()

Gets total number of jobs handled by the node since node startup.

Note: Unlike most of other aggregation metrics this metric is not calculated over history but over the entire node life.

Returns:
  Total number of jobs handled by the node since node startup.

#### getTotalJobsExecutionTime

    long getTotalJobsExecutionTime()

Gets total time all finished jobs takes to execute on the node since node startup.

Note: Unlike most of other aggregation metrics this metric is not calculated over history but over the entire node life.

Returns:
  Total jobs execution time.

#### getMaximumJobWaitTime

    long getMaximumJobWaitTime()

Gets maximum time a job ever spent waiting in a queue to be executed.

Note: all aggregated metrics like average, minimum, maximum, total, count are calculated over all the metrics kept in history. The history size is set via either one or both of configuration settings:

- `IgniteConfiguration.getMetricsExpireTime()`
- `IgniteConfiguration.getMetricsHistorySize()`

Returns:
  Maximum waiting time.

#### getCurrentJobWaitTime

    long getCurrentJobWaitTime()

Gets current time an oldest jobs has spent waiting to be executed.

Returns:
  Current wait time of oldest job.

#### getAverageJobWaitTime

    double getAverageJobWaitTime()

Gets average time jobs spend waiting in the queue to be executed.

Note: all aggregated metrics like average, minimum, maximum, total, count are calculated over all the metrics kept in history. The history size is set via either one or both of configuration settings:

- `IgniteConfiguration.getMetricsExpireTime()`
- `IgniteConfiguration.getMetricsHistorySize()`

Returns:
  Average job wait time.

#### getMaximumJobExecuteTime

    long getMaximumJobExecuteTime()

Gets time it took to execute the longest job on the node.

Note: all aggregated metrics like average, minimum, maximum, total, count are calculated over all the metrics kept in history. The history size is set via either one or both of configuration settings:

- `IgniteConfiguration.getMetricsExpireTime()`
- `IgniteConfiguration.getMetricsHistorySize()`

Returns:
  Time it took to execute the longest job on the node.

#### getCurrentJobExecuteTime

    long getCurrentJobExecuteTime()

Gets longest time a current job has been executing for.

Returns:
  Longest time a current job has been executing for.

#### getAverageJobExecuteTime

    double getAverageJobExecuteTime()

Gets average time a job takes to execute on the node.

Note: all aggregated metrics like average, minimum, maximum, total, count are calculated over all the metrics kept in history. The history size is set via either one or both of configuration settings:

- `IgniteConfiguration.getMetricsExpireTime()`
- `IgniteConfiguration.getMetricsHistorySize()`

Returns:
  Average job execution time.

#### getTotalExecutedTasks

    int getTotalExecutedTasks()

Gets total number of tasks handled by the node.

Note: all aggregated metrics like average, minimum, maximum, total, count are calculated over all the metrics kept in history. The history size is set via either one or both of configuration settings:

- `IgniteConfiguration.getMetricsExpireTime()`
- `IgniteConfiguration.getMetricsHistorySize()`

Returns:
  Total number of jobs handled by the node.

#### getTotalBusyTime

    long getTotalBusyTime()

Gets total time this node spent executing jobs.

Returns:
  Total time this node spent executing jobs.

#### getTotalIdleTime

    long getTotalIdleTime()

Gets total time this node spent idling (not executing any jobs).

Returns:
  Gets total time this node spent idling.

#### getCurrentIdleTime

    long getCurrentIdleTime()

Gets time this node spend idling since executing last job.

Returns:
  Time this node spend idling since executing last job.

#### getBusyTimePercentage

    float getBusyTimePercentage()

Gets percentage of time this node is busy executing jobs vs. idling.

Returns:
  Percentage of time this node is busy (value is less than or equal to `1` and greater than or equal to `0`)

#### getIdleTimePercentage

    float getIdleTimePercentage()

Gets percentage of time this node is idling vs. executing jobs.

Returns:
  Percentage of time this node is idle (value is less than or equal to `1` and greater than or equal to `0`)

#### getTotalCpus

    int getTotalCpus()

Returns the number of CPUs available to the Java Virtual Machine. This method is equivalent to the `Runtime.availableProcessors()` method.

Note that this value may change during successive invocations of the virtual machine.

Returns:
  The number of processors available to the virtual machine, never smaller than one.

#### getCurrentCpuLoad

    double getCurrentCpuLoad()

Returns the CPU usage usage in `[0, 1]` range. The exact way how this number is calculated depends on SPI implementation.

If the CPU usage is not available, a negative value is returned.

This method is designed to provide a hint about the system load and may be queried frequently. The load average may be unavailable on some platform where it is expensive to implement this method.

Returns:
  The estimated CPU usage in `[0, 1]` range. Negative value if not available.

#### getAverageCpuLoad

    double getAverageCpuLoad()

Gets average of CPU load values over all metrics kept in the history.

Note: all aggregated metrics like average, minimum, maximum, total, count are calculated over all the metrics kept in history. The history size is set via either one or both of configuration settings:

- `IgniteConfiguration.getMetricsExpireTime()`
- `IgniteConfiguration.getMetricsHistorySize()`

Returns:
  Average of CPU load value in `[0, 1]` range over all metrics kept in the history.

#### getCurrentGcCpuLoad

    double getCurrentGcCpuLoad()

Returns average time spent in CG since the last update.

Returns:
  Average time spent in CG since the last update.

#### getHeapMemoryInitialized

    long getHeapMemoryInitialized()

Returns the amount of heap memory in bytes that the JVM initially requests from the operating system for memory management. This method returns `-1` if the initial memory size is undefined.

This value represents a setting of the heap memory for Java VM and is not a sum of all initial heap values for all memory pools.

Note: this is not an aggregated metric and it's calculated from the time of the node's startup.

Returns:
  The initial size of memory in bytes; `-1` if undefined.

#### getHeapMemoryUsed

    long getHeapMemoryUsed()

Returns the current heap size that is used for object allocation. The heap consists of one or more memory pools. This value is the sum of `used` heap memory values of all heap memory pools.

The amount of used memory in the returned is the amount of memory occupied by both live objects and garbage objects that have not been collected, if any.

Note: this is not an aggregated metric and it's calculated from the time of the node's startup.

Returns:
  Amount of heap memory used.

#### getHeapMemoryCommitted

    long getHeapMemoryCommitted()

Returns the amount of heap memory in bytes that is committed for the JVM to use. This amount of memory is guaranteed for the JVM to use. The heap consists of one or more memory pools. This value is the sum of `committed` heap memory values of all heap memory pools.

Note: this is not an aggregated metric and it's calculated from the time of the node's startup.

Returns:
  The amount of committed memory in bytes.

#### getHeapMemoryMaximum

    long getHeapMemoryMaximum()

Returns the maximum amount of heap memory in bytes that can be used for memory management. This method returns `-1` if the maximum memory size is undefined.

This amount of memory is not guaranteed to be available for memory management if it is greater than the amount of committed memory. The JVM may fail to allocate memory even if the amount of used memory does not exceed this maximum size.

This value represents a setting of the heap memory for Java VM and is not a sum of all initial heap values for all memory pools.

Note: this is not an aggregated metric and it's calculated from the time of the node's startup.

Returns:
  The maximum amount of memory in bytes; `-1` if undefined.

#### getHeapMemoryTotal

    long getHeapMemoryTotal()

Returns the total amount of heap memory in bytes. This method returns `-1` if the total memory size is undefined.

This amount of memory is not guaranteed to be available for memory management if it is greater than the amount of committed memory. The JVM may fail to allocate memory even if the amount of used memory does not exceed this maximum size.

This value represents a setting of the heap memory for Java VM and is not a sum of all initial heap values for all memory pools.

Note: this is not an aggregated metric and it's calculated from the time of the node's startup.

Returns:
  The total amount of memory in bytes; `-1` if undefined.

#### getNonHeapMemoryInitialized

    long getNonHeapMemoryInitialized()

Returns the amount of non-heap memory in bytes that the JVM initially requests from the operating system for memory management. This method returns `-1` if the initial memory size is undefined.

This value represents a setting of non-heap memory for Java VM and is not a sum of all initial heap values for all memory pools.

Note: this is not an aggregated metric and it's calculated from the time of the node's startup.

Returns:
  The initial size of memory in bytes; `-1` if undefined.

#### getNonHeapMemoryUsed

    long getNonHeapMemoryUsed()

Returns the current non-heap memory size that is used by Java VM. The non-heap memory consists of one or more memory pools. This value is the sum of `used` non-heap memory values of all non-heap memory pools.

Note: this is not an aggregated metric and it's calculated from the time of the node's startup.

Note: this is not an aggregated metric and it's calculated from the time of the node's startup.

Returns:
  Amount of none-heap memory used.

#### getNonHeapMemoryCommitted

    long getNonHeapMemoryCommitted()

Returns the amount of non-heap memory in bytes that is committed for the JVM to use. This amount of memory is guaranteed for the JVM to use. The non-heap memory consists of one or more memory pools. This value is the sum of `committed` non-heap memory values of all non-heap memory pools.

Note: this is not an aggregated metric and it's calculated from the time of the node's startup.

Returns:
  The amount of committed memory in bytes.

#### getNonHeapMemoryMaximum

    long getNonHeapMemoryMaximum()

Returns the maximum amount of non-heap memory in bytes that can be used for memory management. This method returns `-1` if the maximum memory size is undefined.

This amount of memory is not guaranteed to be available for memory management if it is greater than the amount of committed memory. The JVM may fail to allocate memory even if the amount of used memory does not exceed this maximum size.

This value represents a setting of the non-heap memory for Java VM and is not a sum of all initial non-heap values for all memory pools.

Note: this is not an aggregated metric and it's calculated from the time of the node's startup.

Returns:
  The maximum amount of memory in bytes; `-1` if undefined.

#### getNonHeapMemoryTotal

    long getNonHeapMemoryTotal()

Returns the total amount of non-heap memory in bytes that can be used for memory management. This method returns `-1` if the total memory size is undefined.

This amount of memory is not guaranteed to be available for memory management if it is greater than the amount of committed memory. The JVM may fail to allocate memory even if the amount of used memory does not exceed this maximum size.

This value represents a setting of the non-heap memory for Java VM and is not a sum of all initial non-heap values for all memory pools.

Note: this is not an aggregated metric and it's calculated from the time of the node's startup.

Returns:
  The total amount of memory in bytes; `-1` if undefined.

#### getUpTime

    long getUpTime()

Returns the uptime of the JVM in milliseconds.

Returns:
  Uptime of the JVM in milliseconds.

#### getStartTime

    long getStartTime()

Returns the start time of the JVM in milliseconds. This method returns the approximate time when the Java virtual machine started.

Returns:
  Start time of the JVM in milliseconds.

#### getNodeStartTime

    long getNodeStartTime()

Returns the start time of grid node in milliseconds. There can be several grid nodes started in one JVM, so JVM start time will be the same for all of them, but node start time will be different.

Returns:
  Start time of the grid node in milliseconds.

#### getCurrentThreadCount

    int getCurrentThreadCount()

Returns the current number of live threads including both daemon and non-daemon threads.

Returns:
  Current number of live threads.

#### getMaximumThreadCount

    int getMaximumThreadCount()

Returns the maximum live thread count since the JVM started or peak was reset.

Note: this is not an aggregated metric and it's calculated from the time of the node's startup.

Returns:
  The peak live thread count.

#### getTotalStartedThreadCount

    long getTotalStartedThreadCount()

Returns the total number of threads created and also started since the JVM started.

Note: this is not an aggregated metric and it's calculated from the time of the node's startup.

Returns:
  The total number of threads started.

#### getCurrentDaemonThreadCount

    int getCurrentDaemonThreadCount()

Returns the current number of live daemon threads.

Returns:
  Current number of live daemon threads.

#### getLastDataVersion

    long getLastDataVersion()

In-Memory Data Grid assigns incremental versions to all cache operations. This method provides the latest data version on the node.

Returns:
  Last data version.

#### getSentMessagesCount

    int getSentMessagesCount()

Gets sent messages count.

Returns:
  Sent messages count.

#### getSentBytesCount

    long getSentBytesCount()

Gets sent bytes count.

Returns:
  Sent bytes count.

#### getReceivedMessagesCount

    int getReceivedMessagesCount()

Gets received messages count.

Returns:
  Received messages count.

#### getReceivedBytesCount

    long getReceivedBytesCount()

Gets received bytes count.

Returns:
  Received bytes count.

#### getOutboundMessagesQueueSize

    int getOutboundMessagesQueueSize()

Gets outbound messages queue size.

Returns:
  Outbound messages queue size.

#### getTotalNodes

    int getTotalNodes()

Gets total number of nodes.

Returns:
  Total number of nodes.

#### getCurrentPmeDuration

    long getCurrentPmeDuration()

Gets execution duration for current partition map exchange in milliseconds.

Returns:
  Gets execution duration for current partition map exchange in milliseconds. `0` if there is no running PME.

${current.year} Copyright © Apache Software Foundation

Follow @ApacheIgnite

Ignite Database and Caching Platform | : ver. 2.9.0
Release Date | : October 15 2020